#include <iostream>
#include <cstdio>
#include <vector>
#include <iterator>
#include <algorithm>
#include <utility>
#include <string>

int main(){

    std::ios_base::sync_with_stdio(false);

    std::string line;
    while (std::getline(std::cin, line)){
        std::string::reverse_iterator cursor = line.rbegin();
        std::string::reverse_iterator end = line.rend();
        if (*cursor == '0'){
            *cursor = '1';
            std::cout << line << "\n";
            continue;
        }
        
        char expected = '1';
        bool flip = true;
        for (; cursor != end; ++cursor){
            if (!flip) {
                break;
            }
            if (*cursor != expected){
                flip = false;
            }
            *cursor = (*cursor == '0')? '1' : '0';
            expected = (expected == '0')? '1' : '0';
        }
        
        if (flip){
            std::cout << "11" << line << "\n";
        } else {
        
            std::string::iterator start = line.begin(), end = line.end();
            while (start != end && *start == '0'){
                ++start;
            } 
            if (start == end){
                std::cout << "0\n";
            } else {
                for (; start != end; ++start){
                    std::cout << *start;
                }
                std::cout << "\n";

            }
            
        }
        
    
    }

    return 0;
}
